NXOpen .NET Reference Guide  1899
 All Classes Namespaces Functions Variables Enumerations Enumerator Properties
Public Member Functions | Properties | List of all members
NXOpen.Display.DynamicSectionBuilder Class Reference

Represents a Dynamic Section Builder used for creating sections. More...

Inheritance diagram for NXOpen.Display.DynamicSectionBuilder:
NXOpen.Builder NXOpen.TaggedObject NXOpen.GeometricUtilities.IComponentBuilder NXOpen.Utilities.NXRemotableObject IMessageSink NXOpen.Annotations.LightweightSectionBuilder NXOpen.Layout2d.CreateComponentFrom3DBuilder

Public Member Functions

unsafe void AlternatePlane ()
 Cycle through planes that are 90 degrees aligned to the current section plane. More...
 
unsafe NXOpen.DatumPlane CreateDatumPlane ()
 Creates a datum plane from the active section plane. More...
 
unsafe void EditView (NXOpen.ModelingView view)
 Edits the section object in the modeling view. More...
 
unsafe void GetActivePlane (out NXOpen.Display.DynamicSectionTypes.Axis planeAxis, out NXOpen.Display.DynamicSectionTypes.ActivePlane activePlane)
 Gets the active plane in the section. More...
 
unsafe void GetAllPlanesGeometry (out NXOpen.Point3d[] planeOrigins, out NXOpen.Matrix3x3[] planeMetrices)
 Gets geometry for all planes of the section. More...
 
unsafe void GetBoundingBox (out NXOpen.Point3d minCornerPt, out NXOpen.Point3d maxCornerPt)
 Gets bounding box used by the section. More...
 
unsafe
NXOpen.Display.PlaneGridBuilder 
GetGridSettings ()
 Creates a grid settings builder from the active section plane. More...
 
unsafe string GetName ()
 Gets the section name. More...
 
unsafe NXOpen.Vector3d GetNormal ()
 Gets the normal of the section plane More...
 
unsafe double GetOffset ()
 Gets the the plane offset. More...
 
unsafe void GetOffsetLimits (out double minimumOffset, out double maximumOffset)
 Gets minimum and maximum offset limits. More...
 
unsafe NXOpen.Point3d GetOrigin ()
 Gets the section origin. More...
 
unsafe void GetPlaneGeometry (NXOpen.Display.DynamicSectionTypes.Axis axisType, NXOpen.Display.DynamicSectionTypes.ActivePlane planeType, out NXOpen.Point3d origin, out NXOpen.Matrix3x3 matrix)
 Gets geometry of specified plane of the section. More...
 
unsafe double GetPlaneThickness ()
 Gets the thickness between active plane pair. More...
 
unsafe double GetRotationAngle (NXOpen.Display.DynamicSectionTypes.Axis rotationAxis)
 Gets rotation angle for specified axis. More...
 
unsafe NXOpen.Matrix3x3 GetRotationMatrix ()
 Gets the section rotation matrix More...
 
unsafe bool IsAssociativitySupported ()
 Determines if an associative section plane is supported. More...
 
unsafe bool IsDefaultPlane ()
 Indicates whether the section plane is at the default location. More...
 
unsafe bool LoadAllIntersecting (out NXOpen.PartLoadStatus loadStatus)
 Loads all components that intersect the current section plane. More...
 
unsafe bool LoadNearIntersecting (out NXOpen.PartLoadStatus loadStatus)
 Loads components that intersect the current section plane and are near the section plane origin. More...
 
unsafe void OffsetOriginInPlane (double xOffset, double yOffset)
 Offsets section origin within current section plane. More...
 
unsafe void PlaneX ()
 Creates a plane along X direction. More...
 
unsafe void PlaneY ()
 Creates a plane along Y direction. More...
 
unsafe void PlaneZ ()
 Creates a plane along Z direction. More...
 
unsafe void RestoreView ()
 Restores the section to the saved section in the view database. More...
 
unsafe void ReverseDirection ()
 Reverses the plane direction. More...
 
unsafe void SaveCurves (string groupName)
 Creates curves by intersecting all clipping planes of the section with all visible bodies in the scene and adds them to the group created with the specified name. More...
 
unsafe void SetActivePlane (NXOpen.Display.DynamicSectionTypes.Axis planeAxis, NXOpen.Display.DynamicSectionTypes.ActivePlane activePlane)
 Sets the active plane in the section More...
 
unsafe bool SetAllPlanesGeometry (NXOpen.Point3d[] planeOrigins, NXOpen.Matrix3x3[] planeMetrices)
 Sets geometry for all planes of the section. More...
 
unsafe void SetAssociativePlane (NXOpen.Plane planeTag)
 Makes dynamic section associative to the specified plane The plane must be a smart plane; otherwise an error will be reported. More...
 
unsafe void SetBoundingBox (NXOpen.Point3d minCornerPt, NXOpen.Point3d maxCornerPt)
 Sets bounding box for the section. More...
 
unsafe void SetDefaultPlane ()
 Set current section plane to its default definition. More...
 
unsafe void SetDefaults ()
 Set current section to the default values. More...
 
unsafe bool SetName (string sectionName)
 Sets the section name. More...
 
unsafe void SetNormal (NXOpen.Vector3d normal)
 Sets the normal of the section plane More...
 
unsafe void SetOffset (double offset)
 Sets the the plane offset. More...
 
unsafe void SetOffsetByPoint (NXOpen.Point3d point)
 This method offsets the active clipping plane such that the plane passes through the specified point. More...
 
unsafe void SetOrigin (NXOpen.Point3d origin)
 Sets the section origin. More...
 
unsafe void SetPlane (NXOpen.Point3d axisOrigin, NXOpen.Point3d origin, NXOpen.Matrix3x3 rotationMatrix)
 Sets a section plane to be the specified plane The plane is created at the specified origin with the specified rotation matrix. More...
 
unsafe void SetPlaneThickness (double planeThickness)
 Sets the thickness between active plane pair. More...
 
unsafe void SetRotationAngle (NXOpen.Display.DynamicSectionTypes.Axis rotationAxis, double angle)
 Rotates the section about specified axis by the specified angle. More...
 
unsafe void SetRotationMatrix (NXOpen.Display.DynamicSectionTypes.Axis rotationAxis, NXOpen.Matrix3x3 rotationMatrix)
 Sets the section rotation matrix More...
 
unsafe void ShowCurvePreview (bool showCurvePreview)
 Show/hide curve preview. More...
 
unsafe void ShowSectionCurves (bool showCurves)
 Shows the section curves in the view associated with the builder. More...
 
unsafe void UpdateBoxExtents ()
 Update box section display by recomputing the box extents if necessary. More...
 
- Public Member Functions inherited from NXOpen.Builder
unsafe NXOpen.NXObject Commit ()
 Commits any edits that have been applied to the builder. More...
 
unsafe void Destroy ()
 Deletes the builder, and cleans up any objects created by the builder. More...
 
unsafe NXOpen.NXObject[] GetCommittedObjects ()
 For builders that create more than one object, this method returns the objects that are created by commit. More...
 
unsafe NXOpen.NXObject GetObject ()
 Returns the object currently being edited by this builder. More...
 
unsafe void ShowResults ()
 Updates the model to reflect the result of an edit to the model for all builders that support showing results. More...
 
unsafe bool Validate ()
 Validate whether the inputs to the component are sufficient for commit to be called. More...
 
- Public Member Functions inherited from NXOpen.TaggedObject
void PrintTestData (String variableName)
 <exclude> More...
 
void PrintTestData (String variableName, int lineNumber)
 <exclude> More...
 
override string ToString ()
 Returns a String that represents the current Object. More...
 
- Public Member Functions inherited from NXOpen.Utilities.NXRemotableObject
IMessageCtrl AsyncProcessMessage (IMessage msg, IMessageSink replySink)
 Asynchronously processes the given message. More...
 
IMessage SyncProcessMessage (IMessage msg)
 Synchronously processes the given message. More...
 

Properties

unsafe bool BoxExtentDelayUpdate [get, set]
 Returns or sets the delay box extent update. More...
 
unsafe double BoxExtentMargin [get, set]
 Returns or sets the margin for box section extents More...
 
unsafe NXOpen.SelectINXObjectList BoxExtentObjects [get]
 Returns the objects that define the extents for box section. More...
 
unsafe bool BoxExtentSupported [get]
 Returns the box extent support. More...
 
unsafe NXOpen.NXColor CapColor [get, set]
 Returns or sets the cap color. More...
 
unsafe
NXOpen.Display.DynamicSectionTypes.CapColorOption 
CapColorOption [get, set]
 Returns or sets the cap color option More...
 
unsafe
NXOpen.Display.DynamicSectionTypes.Clip 
ClipType [get, set]
 Returns or sets the clip type More...
 
unsafe
NXOpen.Display.DynamicSectionTypes.CoordinateSystem 
CsysType [get, set]
 Returns or sets the coordinate system used for creating section plane along X, Y or Z principal planes. More...
 
unsafe NXOpen.NXColor CurveColor [get, set]
 Returns or sets the curve color. More...
 
unsafe
NXOpen.Display.DynamicSectionTypes.CurveColorOption 
CurveColorOption [get, set]
 Returns or sets the curve color option More...
 
unsafe
NXOpen.Display.DynamicSectionTypes.Axis 
DefaultPlaneAxis [get, set]
 Returns or sets the axis indicating the default plane normal. More...
 
unsafe bool DeferCurveUpdate [get, set]
 Returns or sets the defer curve update property. More...
 
unsafe NXOpen.NXColor InterferenceColor [get, set]
 Returns or sets the interference color. More...
 
unsafe
NXOpen.Display.LayerSettingsBuilder 
LayerSettings [get]
 Returns the layer settings builder More...
 
unsafe bool LockPlanes [get, set]
 Returns or sets the lock planes flag. More...
 
unsafe int NumberInSeries [get, set]
 Returns or sets the number of requested section planes in the current section series. More...
 
unsafe bool ReverseSeries [get, set]
 Returns or sets the reverse series flag More...
 
unsafe double SeriesSpacing [get, set]
 Returns or sets the section plane spacing in the current section series. More...
 
unsafe bool ShowCap [get, set]
 Returns or sets the cap on off flag More...
 
unsafe bool ShowClip [get, set]
 Returns or sets the clip on off flag More...
 
unsafe bool ShowCurves [get, set]
 Returns or sets the curve on off flag. More...
 
unsafe bool ShowGrid [get, set]
 Returns or sets the show grid display flag More...
 
unsafe bool ShowInterference [get, set]
 Returns or sets the interference on off flag. More...
 
unsafe bool ShowViewer [get, set]
 Returns or sets the 2D viewer display flag More...
 
unsafe
NXOpen.Display.DynamicSectionTypes.Type 
Type [get, set]
 Returns or sets the section type More...
 
unsafe NXOpen.ModelingView View [get, set]
 Returns or sets the modeling view in which section object edits are being done. More...
 
- Properties inherited from NXOpen.Builder
unsafe NXOpen.PreviewBuilder PreviewBuilder [get]
 Returns the preview builder subobject. More...
 
- Properties inherited from NXOpen.TaggedObject
Tag Tag [get]
 Returns the tag of this object. More...
 
- Properties inherited from NXOpen.Utilities.NXRemotableObject
IMessageSink NextSink [get]
 Gets the next message sink in the sink chain. More...
 

Additional Inherited Members

- Protected Member Functions inherited from NXOpen.TaggedObject
new void initialize ()
 <exclude> More...
 

Detailed Description

Represents a Dynamic Section Builder used for creating sections.

The dynamic sectioning is performed on a displayable part that is displayed in the modeling work view.It is possible to specify the view after creating the builder. However, the specified view must be modeling work view. This operation is meant to be performed in an interactive mode with visual feedback.

Builder Creation:

The dynamic section builder can be used to create new dynamic section objects OR to edit an existing section object.

See Display.DynamicSectionCollection.CreateSectionBuilder

When a view is specified during the builder creation, the dynamic section object will be activated in the view. When the dynamic section object is activated in the view, view clipping and capping is enabled. However, it is not necessary to specify the view.

There are three different types of sections that are currently being supported.

User can switch between these types at any time.

Assembly and Modeling Operations

All the APIs accept geometric data such as plane origin, plane normal in the absolute coordinate system.

Saving changes

Builder.Commit method will activate the section object in the modeling view. It returns the dynamic section object tag.

Section Plane Families:

An important issue with dynamic sectioning is the ability to easily define a group of related cross-section planes. A group of related cross-section planes will be known as a Plane Family. An important idea in understanding a plane family is the concept of a defining or a Base Plane. The base plane of the plane family is the starting point (i.e. plane) for the plane family. All planes in the family are related by an offset to the base plane. There are two types of plane families:

Linear Plane Family

A linear plane family is defined by an infinite group of parallel planes. All of the planes in a linear family are parallel to its base plane (i.e. along the base plane normal at some linear offset value). This is illustrated below with a base plane and three parallel planes to it that are members of the plane family.

Base Plane

| | | |
| | | |
| | | | ==&gt; Nomal to all planes.
| | | |
| | | |

Axi-Symmetric Plane Family

An axi-symmetric plane family is defined by rotating the base plane about one of the three primary axes. There are an infinite number of planes in an axi-symmetric plane family similar to a linear plane family. This is illustrated below with a base plane and three planes rotated about the z-axis.

\ | /
\ | /
\ | /
\|/____ Base Plane

Switching between plane families

Methods defining a new linear family

Following methods define a new axi-symmetric family

Transition between plane families

When a method defining a new linear family is invoked, then if

The same thing happens when a method defining a new axi-symmetric plane is invoked.

Examples:

1. Linear Family

Goal: User wants to create a series of sections along X axis.

API sequence:

planeX - Create a plane with base plane at X = 0
See <see cref="Display.DynamicSectionBuilder.PlaneX"> Display.DynamicSectionBuilder.PlaneX </see>
SetOffset( 50 ) - Plane at X = 50
SetOffset( 100 ) - Plane at X = 100
SetOffset( 0 ) - Plane at X = 0

2. Axi-symmetric Family

Goal: User wants to create a series of sections by planes rotated around X axis of the section plane.

API sequence:

SetRotation( X, 45 ) - The current plane becomes base plane. Then
the plane rotated around X axis by 45
degrees.
SetRotation( X, 90 ) - Plane rotated around X axis by 90 degrees.
SetRotation( X, 90 ) - Plane rotated around X axis by 0 degrees.
Back to original position.

To create a new instance of this class, use NXOpen.Display.DynamicSectionCollection.CreateSectionBuilder

Default values.

Property Value

BoxExtentDelayUpdate

false

CapColorOption

Any

ClipType

Section

CurveColorOption

Any

LayerSettings.LayerOption

Work

LockPlanes

true

ShowCap

true

ShowClip

true

ShowCurves (deprecated)

false

ShowGrid

false

ShowInterference

false

ShowViewer

false

Type

OnePlane

Created in NX5.0.0

Member Function Documentation

unsafe void NXOpen.Display.DynamicSectionBuilder.AlternatePlane ( )
inline

Cycle through planes that are 90 degrees aligned to the current section plane.

For example, for a XY plane with normal along positive Z axis, invoking this method will cycle through the planes in the following order.

- YZ plane with normal along X axis
- XZ plane with normal along Y axis
- XY plane with normal along Z axis

The section offset and rotation matrix are updated.

Created in NX5.0.0

License requirements: None.

unsafe NXOpen.DatumPlane NXOpen.Display.DynamicSectionBuilder.CreateDatumPlane ( )
inline

Creates a datum plane from the active section plane.

Created in NX5.0.0

License requirements: None.

Returns
Datum plane
unsafe void NXOpen.Display.DynamicSectionBuilder.EditView ( NXOpen.ModelingView  view)
inline

Edits the section object in the modeling view.

The view being edited must be the modeling view. This is provided to handle scenarios when the working view is changed when sectioning is in progress. It is the responsibility of user to save pending changes using Builder.Commit method. Otherwise, any existing changes will be lost.

Created in NX6.0.0

License requirements: None.

Parameters
viewModeling view
unsafe void NXOpen.Display.DynamicSectionBuilder.GetActivePlane ( out NXOpen.Display.DynamicSectionTypes.Axis  planeAxis,
out NXOpen.Display.DynamicSectionTypes.ActivePlane  activePlane 
)
inline

Gets the active plane in the section.

* See Display.DynamicSectionBuilder.SetActivePlane * for details.

Created in NX5.0.0

License requirements: None.

Parameters
planeAxis
activePlane
unsafe void NXOpen.Display.DynamicSectionBuilder.GetAllPlanesGeometry ( out NXOpen.Point3d[]  planeOrigins,
out NXOpen.Matrix3x3[]  planeMetrices 
)
inline

Gets geometry for all planes of the section.

Numnber of planes depends on NXOpen.Display.DynamicSectionBuilder.Type . Z direction of the plane matrix is the plane normal.

Created in NX11.0.0

License requirements: None.

Parameters
planeOrigins
planeMetrices
unsafe void NXOpen.Display.DynamicSectionBuilder.GetBoundingBox ( out NXOpen.Point3d  minCornerPt,
out NXOpen.Point3d  maxCornerPt 
)
inline

Gets bounding box used by the section.

The bounding box is used to compute offset limits (see NXOpen.Display.DynamicSectionBuilder.GetOffsetLimits ).

It is possible that there is no valid bounding box associated with the section. The box is invalid if the X coordinate of min corner point is larger than the X coordinate of max corner point.

Created in NX11.0.0

License requirements: None.

Parameters
minCornerPt
maxCornerPt
unsafe NXOpen.Display.PlaneGridBuilder NXOpen.Display.DynamicSectionBuilder.GetGridSettings ( )
inline

Creates a grid settings builder from the active section plane.

Created in NX6.0.0

License requirements: None.

Returns
unsafe string NXOpen.Display.DynamicSectionBuilder.GetName ( )
inline

Gets the section name.

Caller is expected to free the memory.

Created in NX6.0.0

License requirements: None.

Returns
unsafe NXOpen.Vector3d NXOpen.Display.DynamicSectionBuilder.GetNormal ( )
inline

Gets the normal of the section plane

Created in NX5.0.0

License requirements: None.

Returns
Section plane normal
unsafe double NXOpen.Display.DynamicSectionBuilder.GetOffset ( )
inline

Gets the the plane offset.

Created in NX5.0.0

License requirements: None.

Returns
unsafe void NXOpen.Display.DynamicSectionBuilder.GetOffsetLimits ( out double  minimumOffset,
out double  maximumOffset 
)
inline

Gets minimum and maximum offset limits.

Offset limits are dependent on the active section plane. They are determined based on the model bounding box and location of the active section plane.

Display.DynamicSectionBuilder.SetOffset can specify offset outside the offset limits. In that case the offset limits are extended to include the specified offset.

Created in NX5.0.0

License requirements: None.

Parameters
minimumOffsetMinimum offset
maximumOffsetMinimum offset
unsafe NXOpen.Point3d NXOpen.Display.DynamicSectionBuilder.GetOrigin ( )
inline

Gets the section origin.

Created in NX5.0.0

License requirements: None.

Returns
Section origin
unsafe void NXOpen.Display.DynamicSectionBuilder.GetPlaneGeometry ( NXOpen.Display.DynamicSectionTypes.Axis  axisType,
NXOpen.Display.DynamicSectionTypes.ActivePlane  planeType,
out NXOpen.Point3d  origin,
out NXOpen.Matrix3x3  matrix 
)
inline

Gets geometry of specified plane of the section.

Valid values for section axis and active plane depends on NXOpen.Display.DynamicSectionBuilder.Type . See NXOpen.Display.DynamicSectionBuilder.SetActivePlane for more details on how to specify axis and active plane type. Z direction of plane matrix is the plane normal.

Created in NX11.0.0

License requirements: None.

Parameters
axisType
planeType
originPlane origin
matrixPlane matrix
unsafe double NXOpen.Display.DynamicSectionBuilder.GetPlaneThickness ( )
inline

Gets the thickness between active plane pair.

This is valid when the section contains more than one clipping plane. When the section planes are locked, setting thickness will not alter the current thickness.

Created in NX5.0.0

License requirements: None.

Returns
unsafe double NXOpen.Display.DynamicSectionBuilder.GetRotationAngle ( NXOpen.Display.DynamicSectionTypes.Axis  rotationAxis)
inline

Gets rotation angle for specified axis.

Created in NX5.0.0

License requirements: None.

Parameters
rotationAxis
Returns
Rotation angle in degrees
unsafe NXOpen.Matrix3x3 NXOpen.Display.DynamicSectionBuilder.GetRotationMatrix ( )
inline

Gets the section rotation matrix

Created in NX5.0.0

License requirements: None.

Returns
Rotation matrix
unsafe bool NXOpen.Display.DynamicSectionBuilder.IsAssociativitySupported ( )
inline

Determines if an associative section plane is supported.

Created in NX9.0.0

License requirements: None.

Returns
unsafe bool NXOpen.Display.DynamicSectionBuilder.IsDefaultPlane ( )
inline

Indicates whether the section plane is at the default location.

Section plane is at the default location when builder creates a new section using default plane parameters (specified in the customer defaults) and/or when the section plane location is reset using NXOpen.Display.DynamicSectionBuilder.SetDefaultPlane or NXOpen.Display.DynamicSectionBuilder.SetDefaults . Modifying section plane thereafter will reset the default plane state.

Created in NX11.0.1

License requirements: None.

Returns
unsafe bool NXOpen.Display.DynamicSectionBuilder.LoadAllIntersecting ( out NXOpen.PartLoadStatus  loadStatus)
inline

Loads all components that intersect the current section plane.

Errors are reported by the part load status. Caller is expected to destroy the memory used by load status object.

Created in NX5.0.0

License requirements: adv_assemblies ("ADVANCED ASSEMBLIES")

Returns
New component loaded flag
Parameters
loadStatusErrors occurred during loading of parts.
unsafe bool NXOpen.Display.DynamicSectionBuilder.LoadNearIntersecting ( out NXOpen.PartLoadStatus  loadStatus)
inline

Loads components that intersect the current section plane and are near the section plane origin.

The distance used for which components are "near" the section plane origin is determined internally. Errors are reported by the part load status. Caller is expected to destroy the memory used by load status object.

Created in NX5.0.0

License requirements: adv_assemblies ("ADVANCED ASSEMBLIES")

Returns
New component loaded flag
Parameters
loadStatusErrors occurred during loading of parts.
unsafe void NXOpen.Display.DynamicSectionBuilder.OffsetOriginInPlane ( double  xOffset,
double  yOffset 
)
inline

Offsets section origin within current section plane.

The section is moved to new location along in the section plane. The offsets are w.r.t. current origin along the X and Y axis of the section plane respectively.

Created in NX5.0.0

License requirements: None.

Parameters
xOffsetDelta X from the current position
yOffsetDelta Y from the current position
unsafe void NXOpen.Display.DynamicSectionBuilder.PlaneX ( )
inline

Creates a plane along X direction.

The plane is created with the base plane at the origin with normal along X axis of the coordinate system Display.DynamicSectionBuilder.CsysType .

The location of the plane depends on the bounding box of all parts displayed in the view. The plane is positioned at the center of the bounding box.

Section offset and rotation matrix are updated.

Section thickness is recomputed based on the bounding box.

Created in NX5.0.0

License requirements: None.

unsafe void NXOpen.Display.DynamicSectionBuilder.PlaneY ( )
inline

Creates a plane along Y direction.

The plane is created with the base plane at the origin with normal along Y axis of the coordinate system Display.DynamicSectionBuilder.CsysType .

The location of the plane depends on the bounding box of all parts displayed in the view. The plane is positioned at the center of the bounding box.

Section offset and rotation matrix are updated.

Section thickness is recomputed based on the bounding box.

Created in NX5.0.0

License requirements: None.

unsafe void NXOpen.Display.DynamicSectionBuilder.PlaneZ ( )
inline

Creates a plane along Z direction.

The plane is created with the base plane at the origin with normal along Z axis of the coordinate system Display.DynamicSectionBuilder.CsysType .

The location of the plane depends on the bounding box of all parts displayed in the view. The plane is positioned at the center of the bounding box.

Section offset and rotation matrix are updated.

Section thickness is recomputed based on the bounding box.

Created in NX5.0.0

License requirements: None.

unsafe void NXOpen.Display.DynamicSectionBuilder.RestoreView ( )
inline

Restores the section to the saved section in the view database.

Created in NX5.0.0

License requirements: None.

unsafe void NXOpen.Display.DynamicSectionBuilder.ReverseDirection ( )
inline

Reverses the plane direction.

This will flip the side of the model being clipped.

Section rotation matrix is updated.

Created in NX5.0.0

License requirements: None.

unsafe void NXOpen.Display.DynamicSectionBuilder.SaveCurves ( string  groupName)
inline

Creates curves by intersecting all clipping planes of the section with all visible bodies in the scene and adds them to the group created with the specified name.

The group is displayed in the part navigator. If the customer default "Load Solids/Sheets when Saving Section Curves" is enabled, then this will load exact solid/sheet bodies for the visible lightweight bodies intersecting the clipping planes. This may increase the time and memory used by the operation, but will ensure exact section curves.

Created in NX5.0.0

License requirements: None.

Parameters
groupNameName of the group containing curves
unsafe void NXOpen.Display.DynamicSectionBuilder.SetActivePlane ( NXOpen.Display.DynamicSectionTypes.Axis  planeAxis,
NXOpen.Display.DynamicSectionTypes.ActivePlane  activePlane 
)
inline

Sets the active plane in the section

Single Plane:

Display.DynamicSectionTypes.Axis.Z is the active axis. There is no secondary plane. Only primary plane exists.

Two Parallel Plane Section:

Display.DynamicSectionTypes.Axis.Z is the active axis and primary/secondary plane can be activated.

Box Section:

The active plane pair can be selected by specifying the planeAxis Given an axis, the primary/secondary planes can be activated.

E.g. To activate primary plane along the local X axis use Display.DynamicSectionTypes.Axis.X and Display.DynamicSectionTypes.ActivePlane.Primary .

Created in NX5.0.0

License requirements: None.

Parameters
planeAxis
activePlane
unsafe bool NXOpen.Display.DynamicSectionBuilder.SetAllPlanesGeometry ( NXOpen.Point3d[]  planeOrigins,
NXOpen.Matrix3x3[]  planeMetrices 
)
inline

Sets geometry for all planes of the section.

Numnber of planes specified must be consistent with the current NXOpen.Display.DynamicSectionBuilder.Type .

Created in NX11.0.0

License requirements: None.

Parameters
planeOrigins
planeMetrices
Returns
Indicates if section geometry changed.
unsafe void NXOpen.Display.DynamicSectionBuilder.SetAssociativePlane ( NXOpen.Plane  planeTag)
inline

Makes dynamic section associative to the specified plane The plane must be a smart plane; otherwise an error will be reported.

Associative plane can be specified only if the builder supports associativity (see Display.DynamicSectionBuilder.IsAssociativitySupported ).

Created in NX9.0.0

License requirements: None.

Parameters
planeTagPlane
unsafe void NXOpen.Display.DynamicSectionBuilder.SetBoundingBox ( NXOpen.Point3d  minCornerPt,
NXOpen.Point3d  maxCornerPt 
)
inline

Sets bounding box for the section.

The bounding box is used to compute offset limits (see NXOpen.Display.DynamicSectionBuilder.GetOffsetLimits ). Specifying bounding box has no effect on current section geometry.

The bounding box impacts construction of default section geometry. NXOpen.Display.DynamicSectionBuilder.SetDefaultPlane NXOpen.Display.DynamicSectionBuilder.SetDefaults

Created in NX11.0.0

License requirements: None.

Parameters
minCornerPt
maxCornerPt
unsafe void NXOpen.Display.DynamicSectionBuilder.SetDefaultPlane ( )
inline

Set current section plane to its default definition.

This will only modify section plane geometry.

Following properties affect the default section plane geometry. NXOpen.Display.DynamicSectionBuilder.DefaultPlaneAxis NXOpen.Display.DynamicSectionBuilder.CsysType

Created in NX5.0.0

License requirements: None.

unsafe void NXOpen.Display.DynamicSectionBuilder.SetDefaults ( )
inline

Set current section to the default values.

This will modify all section geometry as well as section attributes.

Following properties affect the default section plane geometry. NXOpen.Display.DynamicSectionBuilder.DefaultPlaneAxis NXOpen.Display.DynamicSectionBuilder.CsysType

Created in NX5.0.0

License requirements: None.

unsafe bool NXOpen.Display.DynamicSectionBuilder.SetName ( string  sectionName)
inline

Sets the section name.

The specified name will be validated. A section is expected to have a unique name in a part. The name may be modified to make it unique within the part.

Created in NX6.0.0

License requirements: None.

Parameters
sectionNameSection name
Returns
If specified name was modified to ensure uniqueness
unsafe void NXOpen.Display.DynamicSectionBuilder.SetNormal ( NXOpen.Vector3d  normal)
inline

Sets the normal of the section plane

Section offset and rotation matrix are updated.

Created in NX5.0.0

License requirements: None.

Parameters
normalSection plane normal
unsafe void NXOpen.Display.DynamicSectionBuilder.SetOffset ( double  offset)
inline

Sets the the plane offset.

When there are more than one clipping planes in the section, the active clipping plane will be not be allowed to cross-over the non-active clipping plane.

If Display.DynamicSectionBuilder.LockPlanes is off, section thickness is updated.

Created in NX5.0.0

License requirements: None.

Parameters
offsetOffset
unsafe void NXOpen.Display.DynamicSectionBuilder.SetOffsetByPoint ( NXOpen.Point3d  point)
inline

This method offsets the active clipping plane such that the plane passes through the specified point.

When there are more than one clipping planes in the section, the active clipping plane will be not be allowed to cross-over the non-active clipping plane.

See Display.DynamicSectionBuilder.SetOffset

Created in NX5.0.0

License requirements: None.

Parameters
pointPoint in absolute coordinate system.
unsafe void NXOpen.Display.DynamicSectionBuilder.SetOrigin ( NXOpen.Point3d  origin)
inline

Sets the section origin.

The section is moved to new location. It obeys the lock flag Display.DynamicSectionBuilder.LockPlanes . if it is a multiple plane section.

Section offset is updated.

Created in NX5.0.0

License requirements: None.

Parameters
originSection origin
unsafe void NXOpen.Display.DynamicSectionBuilder.SetPlane ( NXOpen.Point3d  axisOrigin,
NXOpen.Point3d  origin,
NXOpen.Matrix3x3  rotationMatrix 
)
inline

Sets a section plane to be the specified plane The plane is created at the specified origin with the specified rotation matrix.

The axis origin can be same as the plane origin. To defind a linear plane family from the absolute origin, define axis origin as {0, 0, 0}. The section offset will reflect the distance of the plane from the axis origin.

Section offset and rotation matrix are updated.

Created in NX5.0.0

License requirements: None.

Parameters
axisOriginAxis origin
originPlane origin.
rotationMatrixRotation matrix
unsafe void NXOpen.Display.DynamicSectionBuilder.SetPlaneThickness ( double  planeThickness)
inline

Sets the thickness between active plane pair.

This property is only available when the section contains more than one clipping plane. When the section planes are locked, setting thickness will not alter the current thickness.

Created in NX5.0.0

License requirements: None.

Parameters
planeThicknessActive plane thickness
unsafe void NXOpen.Display.DynamicSectionBuilder.SetRotationAngle ( NXOpen.Display.DynamicSectionTypes.Axis  rotationAxis,
double  angle 
)
inline

Rotates the section about specified axis by the specified angle.

If a rotation already exists about the specified axis, then the section is rotated such that the total rotation angle is set to the specified angle. Rotation about only one axis is active at a time.

1. Create plane with normal along Z.
2. <see cref="Display.DynamicSectionBuilder.SetRotationAngle"> Display.DynamicSectionBuilder.SetRotationAngle </see>( X, 30 )
Rotates plane around X axis by 30 degrees
3. <see cref="Display.DynamicSectionBuilder.SetRotationAngle"> Display.DynamicSectionBuilder.SetRotationAngle </see>( X, 45 )
Incremental rotation of 45 - 30 = 15 degrees.

Section offset and rotation matrix are updated.

Created in NX5.0.0

License requirements: None.

Parameters
rotationAxis
angleRotation angle in degrees
unsafe void NXOpen.Display.DynamicSectionBuilder.SetRotationMatrix ( NXOpen.Display.DynamicSectionTypes.Axis  rotationAxis,
NXOpen.Matrix3x3  rotationMatrix 
)
inline

Sets the section rotation matrix

Specify Display.DynamicSectionTypes.Axis.None if the axis about which rotation was performed is not known.

Section offset and rotation matrix are updated.

Created in NX5.0.0

License requirements: None.

Parameters
rotationAxis
rotationMatrixRotation matrix
unsafe void NXOpen.Display.DynamicSectionBuilder.ShowCurvePreview ( bool  showCurvePreview)
inline

Show/hide curve preview.

When editing a view section, curve preview can be shown while the editing is in progress. The preview is removed once the changes are committed on the builder or when the builder is destroyed.

Hiding preview will remove the section series preview too.

Created in NX10.0.0

License requirements: None.

Parameters
showCurvePreview
unsafe void NXOpen.Display.DynamicSectionBuilder.ShowSectionCurves ( bool  showCurves)
inline

Shows the section curves in the view associated with the builder.

If no view is associated with the builder, then the curves are Shown in the current work view.

Created in NX7.5.0

License requirements: None.

Parameters
showCurves
unsafe void NXOpen.Display.DynamicSectionBuilder.UpdateBoxExtents ( )
inline

Update box section display by recomputing the box extents if necessary.

Use Display.DynamicSectionBuilder.BoxExtentSupported to determine if extent construction is supported before querying or setting extent attributes.

Created in NX10.0.0

License requirements: None.

Property Documentation

unsafe bool NXOpen.Display.DynamicSectionBuilder.BoxExtentDelayUpdate
getset

Returns or sets the delay box extent update.

This determines if the box section extent updates are delayed when selection list is modified (see Display.DynamicSectionBuilder.BoxExtentObjects ).

If true then use Display.DynamicSectionBuilder.UpdateBoxExtents to update the box section. If false then update happens immediately.

Use Display.DynamicSectionBuilder.BoxExtentSupported to determine if extent construction is supported before querying or setting extent attributes.

Created in NX10.0.0

License requirements to get this property: None.

License requirements to set this property: None.

unsafe double NXOpen.Display.DynamicSectionBuilder.BoxExtentMargin
getset

Returns or sets the margin for box section extents

Use Display.DynamicSectionBuilder.BoxExtentSupported to determine if extent construction is supported before querying or setting extent attributes.

Created in NX10.0.0

License requirements to get this property: None.

License requirements to set this property: None.

unsafe NXOpen.SelectINXObjectList NXOpen.Display.DynamicSectionBuilder.BoxExtentObjects
get

Returns the objects that define the extents for box section.

Absence of the object list indicates that the extent construction is not supported.

Created in NX10.0.0

License requirements: None.

unsafe bool NXOpen.Display.DynamicSectionBuilder.BoxExtentSupported
get

Returns the box extent support.

This is used to determine if the box extent construction is supported. Any box extent related APIs will not function when the extent construction is not supported.

Created in NX10.0.0

License requirements: None.

unsafe NXOpen.NXColor NXOpen.Display.DynamicSectionBuilder.CapColor
getset

Returns or sets the cap color.

Used when cap color type is Display.DynamicSectionTypes.CapColorOption.Any

Created in NX5.0.0

License requirements to get this property: None.

License requirements to set this property: None.

unsafe NXOpen.Display.DynamicSectionTypes.CapColorOption NXOpen.Display.DynamicSectionBuilder.CapColorOption
getset

Returns or sets the cap color option

Created in NX5.0.0

License requirements to get this property: None.

License requirements to set this property: None.

unsafe NXOpen.Display.DynamicSectionTypes.Clip NXOpen.Display.DynamicSectionBuilder.ClipType
getset

Returns or sets the clip type

Created in NX5.0.0

License requirements to get this property: None.

License requirements to set this property: None.

unsafe NXOpen.Display.DynamicSectionTypes.CoordinateSystem NXOpen.Display.DynamicSectionBuilder.CsysType
getset

Returns or sets the coordinate system used for creating section plane along X, Y or Z principal planes.

Specifying the coordinate system has no effect on the current section geometry.

This is used in conjunction with NXOpen.Display.DynamicSectionBuilder.DefaultPlaneAxis to determine default plane constructed by following methods. NXOpen.Display.DynamicSectionBuilder.SetDefaultPlane NXOpen.Display.DynamicSectionBuilder.SetDefaults

Created in NX5.0.0

License requirements to get this property: None.

License requirements to set this property: None.

unsafe NXOpen.NXColor NXOpen.Display.DynamicSectionBuilder.CurveColor
getset

Returns or sets the curve color.

Used when the curve color option is set to Display.DynamicSectionTypes.CurveColorOption.Any .

Created in NX5.0.0

License requirements to get this property: None.

License requirements to set this property: None.

unsafe NXOpen.Display.DynamicSectionTypes.CurveColorOption NXOpen.Display.DynamicSectionBuilder.CurveColorOption
getset

Returns or sets the curve color option

Created in NX5.0.0

License requirements to get this property: None.

License requirements to set this property: None.

unsafe NXOpen.Display.DynamicSectionTypes.Axis NXOpen.Display.DynamicSectionBuilder.DefaultPlaneAxis
getset

Returns or sets the axis indicating the default plane normal.

Display.DynamicSectionTypes.Axis.None is invalid. For example; specify Display.DynamicSectionTypes.Axis.Z to use XY plane as the default plane. Specifying the default plane has no effect on the current section geometry.

This is used in conjunction with NXOpen.Display.DynamicSectionBuilder.CsysType to determine default plane constructed by following methods. NXOpen.Display.DynamicSectionBuilder.SetDefaultPlane NXOpen.Display.DynamicSectionBuilder.SetDefaults

Created in NX11.0.1

License requirements to get this property: None.

License requirements to set this property: None.

unsafe bool NXOpen.Display.DynamicSectionBuilder.DeferCurveUpdate
getset

Returns or sets the defer curve update property.

This property can be used to reduce number of curve updates when performing a series of attribute changes on the dynamic section. After the changes are done, undefer the curve update. Undeferring will update the curves, if and only if, curve update is required based on the applied changes.

Created in NX8.0.0

License requirements to get this property: None.

License requirements to set this property: None.

unsafe NXOpen.NXColor NXOpen.Display.DynamicSectionBuilder.InterferenceColor
getset

Returns or sets the interference color.

Created in NX5.0.0

License requirements to get this property: None.

License requirements to set this property: None.

unsafe NXOpen.Display.LayerSettingsBuilder NXOpen.Display.DynamicSectionBuilder.LayerSettings
get

Returns the layer settings builder

Created in NX9.0.0

License requirements: None.

unsafe bool NXOpen.Display.DynamicSectionBuilder.LockPlanes
getset

Returns or sets the lock planes flag.

The planes can be locked in case of Two Parallel Planes and Box Section. When locked the planes will move together.

Created in NX5.0.0

License requirements to get this property: None.

License requirements to set this property: None.

unsafe int NXOpen.Display.DynamicSectionBuilder.NumberInSeries
getset

Returns or sets the number of requested section planes in the current section series.

Created in NX6.0.0

License requirements to get this property: None.

License requirements to set this property: None.

unsafe bool NXOpen.Display.DynamicSectionBuilder.ReverseSeries
getset

Returns or sets the reverse series flag

Created in NX6.0.0

License requirements to get this property: None.

License requirements to set this property: None.

unsafe double NXOpen.Display.DynamicSectionBuilder.SeriesSpacing
getset

Returns or sets the section plane spacing in the current section series.

Created in NX6.0.0

License requirements to get this property: None.

License requirements to set this property: None.

unsafe bool NXOpen.Display.DynamicSectionBuilder.ShowCap
getset

Returns or sets the cap on off flag

Created in NX5.0.0

License requirements to get this property: None.

License requirements to set this property: None.

unsafe bool NXOpen.Display.DynamicSectionBuilder.ShowClip
getset

Returns or sets the clip on off flag

Created in NX5.0.0

License requirements to get this property: None.

License requirements to set this property: None.

unsafe bool NXOpen.Display.DynamicSectionBuilder.ShowCurves
getset

Returns or sets the curve on off flag.

When the dynamic section object is visible in the view, the curves from the section object are shown in that view.

Created in NX5.0.0

Deprecated in NX6.0.0. Use ModelingView.IsDynamicSectionVisible instead.

License requirements to get this property: None.

License requirements to set this property: None.

unsafe bool NXOpen.Display.DynamicSectionBuilder.ShowGrid
getset

Returns or sets the show grid display flag

Created in NX6.0.0

License requirements to get this property: None.

License requirements to set this property: None.

unsafe bool NXOpen.Display.DynamicSectionBuilder.ShowInterference
getset

Returns or sets the interference on off flag.

Created in NX5.0.0

License requirements to get this property: None.

License requirements to set this property: None.

unsafe bool NXOpen.Display.DynamicSectionBuilder.ShowViewer
getset

Returns or sets the 2D viewer display flag

Created in NX6.0.0

License requirements to get this property: None.

License requirements to set this property: None.

unsafe NXOpen.Display.DynamicSectionTypes.Type NXOpen.Display.DynamicSectionBuilder.Type
getset

Returns or sets the section type

Created in NX5.0.0

License requirements to get this property: None.

License requirements to set this property: None.

unsafe NXOpen.ModelingView NXOpen.Display.DynamicSectionBuilder.View
getset

Returns or sets the modeling view in which section object edits are being done.

Display.DynamicSectionBuilder.View method is present for legacy reasons.

Use Display.DynamicSectionBuilder.EditView instead.

Created in NX5.0.0

License requirements to get this property: None.

License requirements to set this property: None.


The documentation for this class was generated from the following file:
Copyright 2019 Siemens Product Lifecycle Management Software Inc. All Rights Reserved.